namespace Amanotes.TripleSDK.Core.Analytics
{
    public interface IULSAnalytics {
        ULSContext Context { get; }
        /// <summary>
        /// Triggered if a users tries to login into the product, this can happen on any login CTA
        /// </summary>
        void LogEventLogin();
        /// <summary>
        /// Triggered if a user clicks share to social on any of the social call to actions
        /// </summary>
        void LogEventSocialShare();
        /// <summary>
        /// If the user links their profile to another login platform different from their original logn method
        /// </summary>
        void LogEventLoginPassport();
        /// <summary>
        /// Triggers when a user navigates or interacts with their user profile page
        /// </summary>
        void LogEventUserProfile();
        /// <summary>
        /// Triggers when a logged in user adds a follower to their follow list
        /// </summary>
        void LogEventFollow();
        /// <summary>
        /// Triggers when a logged in user removes a follower from their follow list
        /// </summary>
        void LogEventUnfollow();
        /// <summary>
        /// Triggers when a logged in user navigates to another user's social profile
        /// </summary>
        void LogEventSocialProfile();
        /// <summary>
        /// Triggers when a user interacts with the leaderboard
        /// </summary>
        void LogEventGameLeaderboard();
        /// <summary>
        /// Triggers when a user clicks the logout button on the user profile page        
        /// </summary>
        void LogEventLogout();
    }
}