namespace Amanotes.TripleSDK.Core.Analytics
{
    [InjectService]
    [UnityEngine.Scripting.Preserve]
    public sealed class ULSContext
    {
        /// <summary>
        /// facebook, google, appleID, Wechat etc.
        /// </summary>
        public string LoginPlatform { get; set; }

        /// <summary>
        /// Introductory song_end, leaderboard, cross_promotion, subscription
        /// </summary>
        public string Screen { get; set; }

        /// <summary>
        /// What session the user logged into product on
        /// </summary>
        public string SessionId { get; set; }

        /// <summary>
        /// Attaches ama_id to anonymous ama_id
        /// </summary>
        public string AmaId { get; set; }

        /// <summary>
        /// Boolean value describing the result
        /// </summary>
        public bool Result { get; set; }

        /// <summary>
        /// Which social platform the response was sent to FB, TikTok, Instagram etc.
        /// </summary>
        public string SocialPlatform { get; set; }

        /// <summary>
        /// facebook, google, apple
        /// </summary>
        public string PassportPlatform { get; set; }

        /// <summary>
        /// What is the song that the leaderboard is comparing users against
        /// </summary>
        public string SongId { get; set; }

        /// <summary>
        /// The current rank of the player compared to others
        /// </summary>
        public int Rank { get; set; }

        /// <summary>
        /// What geo the leaderboard is returning
        /// </summary>
        public string Geo { get; set; }        
    }
}