﻿using Amanotes.TripleSDK.Core;
using Amanotes.TripleSDK.Core.Analytics;
using Amanotes.TripleSDK.Core.Configuration;
using Amanotes.TripleSDK.Countly;
using Newtonsoft.Json;
using Plugins.Countly;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;

namespace Amanotes.TripleSDK.Firebase
{    
    public class AuthCountlyService : CountlyServiceBase
    {
        void Start()
        {            
            Init();
        }

        public override void Init()
        {
            var Auth = new Plugins.Countly.Models.CountlyAuthModel
            {
                AppKey = "be4caaea95eaef365ad1703253c80793da6e50d2",
                DeviceId = "",
                ServerUrl = "https://eventmgt.amanotes.io/"
            };

            var Config = new Plugins.Countly.Models.CountlyConfigModel(
                salt: "",
                enablePost: false,
                enableConsoleErrorLogging: false,
                ignoreSessionCooldown: false,
                enableManualSessionHandling: false,
                sessionDuration: 60,
                eventViewThreshold: 1,
                storedRequestLimit: 1,
                totalBreadcrumbsAllowed: 100,
                notificationMode: Plugins.Countly.Enums.TestMode.None,
                enableAutomaticCrashReporting: true
            );

#if !UNITY_EDITOR
            var Countly = this.gameObject.AddComponent<Plugins.Countly.Impl.AuthCountly>();
            Countly.Auth = Auth;
            Countly.Config = Config;
#else
            CountlyWrapper = this.gameObject.AddComponent<Plugins.Countly.Impl.CountlyWrapper>();
#endif
            serviceStatus = ServiceStatus.Available;
        }

        protected override IEnumerator LazyLogEvent(string eventName, Dictionary<string, object> param = null)
        {
#if !UNITY_EDITOR
            var checkNull = Plugins.Countly.Impl.AuthCountly.Instance.Events == null; 
#else
            var checkNull = CountlyWrapper.Events == null;
#endif
            while (GetStatus() != ServiceStatus.Available ||
                checkNull)
            {
                yield return null;
            }

            if (param != null)
            {

#if !UNITY_EDITOR
                Plugins.Countly.Impl.AuthCountly.Instance.Events.ReportCustomEventAsync(eventName, param);
#else
                CountlyWrapper.Events.ReportCustomEventAsync(eventName, param);
#endif
            }
            else
            {

#if !UNITY_EDITOR
                Plugins.Countly.Impl.AuthCountly.Instance.Events.RecordEventAsync(eventName);
#else
                CountlyWrapper.Events.RecordEventAsync(eventName);
#endif
            }

        }
    }
}
